#NoTrayIcon
#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=art\delogo.ico
#AutoIt3Wrapper_Compression=4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Coded by Irongeek from Irongeek.com, modded by jabzor
; http://www.irongeek.com/i.php?page=security/decaffeinatid-simple-ids-arpwatch-for-windows
; Icon based on one from from http://commons.wikimedia.org/wiki/Image:Icona_del_Tauler_de_la_Taverna_de_la_Viquip%C3%A8dia.png
#include <ButtonConstants.au3> ; for about form - ok button, groups
#include <EditConstants.au3> ; for about form - license editbox
#include <GUIConstantsEx.au3> ; for systray menu 'checked' items
#include <StaticConstants.au3> ; for about form labels
#include <WindowsConstants.au3> ; for about form gui
#include <AVIConstants.au3> ; for about form - transparent 'about' program icon
#include <EventLog.au3>
#include <Constants.au3>
#include <Array.au3>
#include <String.au3>
#include <file.au3>
#include <iNet.au3>
#include "include\ModernMenuRaw.au3" ; for advanced systray context-menu with icons, context menu side-title
Local $title = "DecaffeinatID" ;  program title
Local $ver = "0.05" ;  program version
Local $subver = "beta" ; program sub-version, 'beta' or 'final'
Local $release = "last modified:  June 23th, 2008." ; program release date
Local $description = "This program monitors suspicious network and system activity."
Local $license = $title & " is freeware (intended for non-commercial use only)." & @CRLF _
		 & "Modify/redistribute with full source and this license attached." & @CRLF & @CRLF _
		 & "Please send code-changes/bug-reports to irongeek@irongeek.com" & @CRLF _
		 & "This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even an implied warranty." & @CRLF _
		 & "Use at your own risk!" & @CRLF & @CRLF _
		 & "Thanks to the contributors:" & @CRLF _
		 & " - MirrorShades @ binrev : the awesome program name" & @CRLF _
		 & " - jabzor @ binrev : feature suggestions and additional coding" & @CRLF _
		 & ".. perhaps you?"
Local $systrayicon = @ScriptName
Local $aboutimage = "art\delogo.avi"

;-----write initial ini values ------
If Not FileExists($title & ".ini") Then
	;program config
	IniWrite($title & ".ini", "config", "sleep", 1000)
	IniWrite($title & ".ini", "config", "firewalllog", @WindowsDir & "\pfirewall.log")
	;networks to monitor
	IniWrite($title & ".ini", "networks", "ignorenetworksrc", "x")
	;events to monitor
	IniWrite($title & ".ini", "events", "ignoreeventids", "")
	IniWrite($title & ".ini", "events", "monitorarpcache", 1)
	IniWrite($title & ".ini", "events", "monitorgateways", 1)
	IniWrite($title & ".ini", "events", "monitorfirewall", 1)
	IniWrite($title & ".ini", "events", "monitorsecevent", 1)
EndIf

;----- systray context menu ------
Local $nTrayIcon = _TrayIconCreate($title & " " & $ver, $systrayicon, -1)
_TrayIconSetClick(-1, 16)
_TrayIconSetState()
Local $bUseAdvTrayMenu = False ;  join the menu icon + text, default = separate columns
Local $nTrayMenu = _TrayCreateContextMenu() ; context menu for the systray
Local $nSideItem = _CreateSideMenu($nTrayMenu) ; side menu, for the vertical context menu title
_SetSideMenuText($nSideItem, $title) ; set the side menu title to the program title
Local $MonitorMenu = _TrayCreateMenu("Monitor")
_TrayItemSetIcon(-1, "shell32.dll", -22) ;  write icon
Local $ArpWatch = _TrayCreateItem("ARP Cache", $MonitorMenu, -1, 0)
;GUICtrlSetState(-1, $GUI_CHECKED)
Local $GatewayWatch = _TrayCreateItem("Default Gateways", $MonitorMenu, -1, 0)
Local $FirewallWatch = _TrayCreateItem("Windows Firewall Log", $MonitorMenu, -1, 0)
Local $SecEvntWatch = _TrayCreateItem("Security Event Log", $MonitorMenu, -1, 0)
Local $TrayEditIni = _TrayCreateItem("Edit Settings in INI")
GUICtrlSetState($TrayEditIni, $GUI_DEFBUTTON)
_TrayItemSetIcon(-1, "shell32.dll", -22) ; search icon
Local $TrayLogs = _TrayCreateItem("View Logs")
GUICtrlSetState($TrayLogs, $GUI_DEFBUTTON)
_TrayItemSetIcon(-1, "shell32.dll", -56) ; search icon
Local $TrayUpdate = _TrayCreateItem("Update...")
_TrayItemSetIcon(-1, "shell32.dll", -25) ; run icon
Local $TrayAbout = _TrayCreateItem("About..")
_TrayItemSetIcon(-1, "shell32.dll", -24) ;  help icon
_TrayCreateItem("") ; separator-bar
Local $TrayExit = _TrayCreateItem("Exit")
_TrayItemSetIcon(-1, "shell32.dll", -28) ;  shutdown icon

;----- about dialog box ------
Local $dlgAbout = GUICreate(" About " & $title & "..", 401, 340, 600, 335, BitOR($WS_SYSMENU, $WS_CAPTION, $WS_POPUP, $WS_POPUPWINDOW, $WS_BORDER, $DS_MODALFRAME), _
		BitOR($WS_EX_TOPMOST, $WS_EX_TOOLWINDOW, $WS_EX_WINDOWEDGE)) ; dialog box - ontop, no systray entry, mini caption with little 'x', hit escape to exit
GUICtrlCreateGroup(" " & $title & " License ", 16, 88, 370, 220, $BS_CENTER)
GUICtrlCreateEdit("", 32, 120, 340, 168, BitOR($ES_AUTOVSCROLL, $ES_READONLY, $WS_VSCROLL), 0) ; wrapping editbox for license-info
GUICtrlSetData(-1, $license) ;  apply license-info to editbox
GUICtrlCreateLabel($title & " " & $ver & " " & $subver, 64, 12, 247, 17) ;  program title
Local $Website = GUICtrlCreateLabel("http://www.irongeek.com/", 64, 28, 158, 17) ; program website
GUICtrlSetFont(-1, 8, 800, 4, "MS Sans Serif") ; weblink underline
GUICtrlSetColor(-1, 0x0000FF) ;  weblink blue font
GUICtrlSetCursor(-1, 0) ;  weblink click-style cursor, on mouse-over
GUICtrlCreateLabel($description, 64, 54, 300, 17) ; 'this program ..'
GUICtrlCreateLabel($release, 32, 320, 340, 17, $SS_CENTER) ; 'last modified ..'
GUICtrlCreateAvi($aboutimage, -1, 12, 12, 42, 42) ; transparent about program image, top left
GUISetState(@SW_HIDE); GUI hidden by default

;-----populate initial values from ini ------
Global $SleepAmount = IniRead("decaffeinatid.ini", "config", "sleep", 1000)
Global $WinFWLog = IniRead("decaffeinatid.ini", "config", "firewalllog", @WindowsDir & "\pfirewall.log")
; INSERT DEFAULT WinFWLog value_here
Global $IgnoreNetworkSrc = IniRead("decaffeinatid.ini", "networks", "ignorenetworksrc", "x")
; INSERT DEFAULT IgnoreNetworkSrc value_here
Global $IgnoreEventIDs = IniRead("decaffeinatid.ini", "events", "ignoreeventids", "") ; populate here with default event ids to ignore
; INSERT DEFAULT IgnoreEventIDS value_here
Global $monitorarpcache = IniRead("decaffeinatid.ini", "events", "monitorarpcache", "1")
If $monitorarpcache <> 0 Then
	$monitorarpcache = 1
	GUICtrlSetState($ArpWatch, $GUI_CHECKED = $GUI_CHECKED)
EndIf
Global $monitorgateways = IniRead("decaffeinatid.ini", "events", "monitorgateways", "1")
If $monitorgateways <> 0 Then
	$monitorgateways = 1
	GUICtrlSetState($GatewayWatch, $GUI_CHECKED = $GUI_CHECKED)
EndIf
Global $monitorfirewall = IniRead("decaffeinatid.ini", "events", "monitorfirewall", "1")
If $monitorfirewall <> 0 Then
	$monitorfirewall = 1
	GUICtrlSetState($FirewallWatch, $GUI_CHECKED = $GUI_CHECKED)
EndIf
Global $monitorsecevent = IniRead("decaffeinatid.ini", "events", "monitorsecevent", "1")
If $monitorsecevent <> 0 Then
	$monitorsecevent = 1
	GUICtrlSetState($SecEvntWatch, $GUI_CHECKED = $GUI_CHECKED)
EndIf

Global $fwfile = FileOpen($WinFWLog, 0)
Global $fwfilesize = FileGetSize($WinFWLog)
Global $oldrecnum = 0

Global $OldARPArray = LoadARPArray(GetARPTable())
Global $NewARPArray = LoadARPArray(GetARPTable())
Global $IP_Gateway_List = IP_Gateway_List()
Global $timermonitorfirewall = TimerInit()
Global $timermonitorsecevent = TimerInit()
Global $timermonitorarpcache = TimerInit()
;----- main program loop ------
While 1
	If $monitorfirewall = 1 And TimerDiff($timermonitorfirewall) > $SleepAmount Then
		Do_FireWall_Log()
		$timermonitorfirewall = TimerInit()
	EndIf
	If $monitorsecevent = 1 And TimerDiff($timermonitorsecevent) > $SleepAmount * 2 Then
		Do_Eventlog()
		$timermonitorsecevent = TimerInit()
	EndIf
	If $monitorarpcache = 1 And TimerDiff($timermonitorarpcache) > $SleepAmount * 3 Then
		Do_ARP_Watch()
		$timermonitorarpcache = TimerInit()
	EndIf

	$Msg = GUIGetMsg() ; iterate through the program messages
	Switch $Msg
		Case $TrayExit ; valid shutdown
			ExitLoop
		Case $ArpWatch ; ArpWatch = checkbox, monitorarpcache = inivalue
			If BitAND(GUICtrlRead($ArpWatch), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($ArpWatch, $GUI_UNCHECKED)
				$monitorarpcache = 0 ; uncheck
			Else
				GUICtrlSetState($ArpWatch, $GUI_CHECKED = $GUI_CHECKED)
				$monitorarpcache = 1 ; check
			EndIf
			IniWrite($title & ".ini", "events", "monitorarpcache", $monitorarpcache)
		Case $GatewayWatch ; GatewayWatch = checkbox, monitorgateways = inivalue
			If BitAND(GUICtrlRead($GatewayWatch), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($GatewayWatch, $GUI_UNCHECKED)
				$monitorgateways = 0 ; uncheck
			Else
				GUICtrlSetState($GatewayWatch, $GUI_CHECKED = $GUI_CHECKED)
				$monitorgateways = 1 ; check
			EndIf
			MsgBox(0, "NOTE:", "This feature is not yet added")
			IniWrite($title & ".ini", "events", "monitorgateways", $monitorgateways)
		Case $FirewallWatch ; FirewallWatch = checkbox, monitorfirewall = inivalue
			If BitAND(GUICtrlRead($FirewallWatch), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($FirewallWatch, $GUI_UNCHECKED)
				$monitorfirewall = 0 ; uncheck
			Else
				GUICtrlSetState($FirewallWatch, $GUI_CHECKED = $GUI_CHECKED)
				$monitorfirewall = 1 ; check
			EndIf
			IniWrite($title & ".ini", "events", "monitorfirewall", $monitorfirewall)
		Case $SecEvntWatch ;SecEvntWatch = checkbox, monitorsecevent = inivalue
			If BitAND(GUICtrlRead($SecEvntWatch), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlSetState($SecEvntWatch, $GUI_UNCHECKED)
				$monitorsecevent = 0 ; uncheck
			Else
				GUICtrlSetState($SecEvntWatch, $GUI_CHECKED = $GUI_CHECKED)
				$monitorsecevent = 1 ; check
			EndIf
			IniWrite($title & ".ini", "events", "monitorsecevent", $monitorsecevent)
		Case $TrayEditIni ; Edit ini
			Run(@ComSpec & ' /c start ' & $title & ".ini", '', @SW_HIDE) ; open the ini file
		Case $TrayLogs ; view logs
			Run(@ComSpec & ' /c start idslog.txt', '', @SW_HIDE) ; open the log file
		Case $TrayUpdate, $Website ; visit website
			Run(@ComSpec & ' /c start http://www.irongeek.com/i.php?page=security/decaffeinatid-simple-ids-arpwatch-for-windows^&ver=' & $ver, '', @SW_HIDE) ; visit update website
		Case $TrayAbout ; show the about box
			GUISetState(@SW_SHOW, $dlgAbout)
		Case $GUI_EVENT_CLOSE ;  hide the about box, hit escape or click the little 'x'
			GUISetState(@SW_HIDE, $dlgAbout)
	EndSwitch
	ContinueLoop ; do while 1
WEnd

Func Do_ARP_Watch()
	Local $j, $i, $newmac, $oldmac, $messtring
	$j = 0
	For $i = 0 To UBound($NewARPArray) - 1
		$ip = $NewARPArray[$i][0]
		$newmac = Get_MAC_of_IP_From_Array($NewARPArray, $ip)
		$oldmac = Get_MAC_of_IP_From_Array($OldARPArray, $ip)
		If $newmac <> $oldmac Then
			If $oldmac = "00-00-00-00-00-00" Then
				$messtring = "New IP in cache: " & $ip & " with MAC of " & $newmac
			Else
				$messtring = "IP " & $ip & " changed MAC from " & $oldmac & " to " & $newmac
				If StringInStr($IP_Gateway_List, $ip) Then
					$messtring = $messtring & @CRLF & "WARNING!!!" & @CRLF & "This IP is a Gateway!!! Something weird is up!!!"
					MsgBox(0, "Big Problem", $messtring) ; should this really be a message box?? - jabzor
				EndIf
			EndIf
			_TrayTip($nTrayIcon, "ARP Watcher", $messtring, 3, 4)
			FileWrite("idslog.txt", @YEAR & @MON & @MDAY & @HOUR & @MIN & @SEC & ": " & $messtring & @CRLF)

		EndIf
		;if $ip = "invalid" Then
		;	_ArrayDisplay($NewARPArray)
		;	_ArrayDisplay($OldARPArray)
		;EndIf
		;ConsoleWrite($i & @CRLF)
		;ConsoleWrite($ip & @CRLF)
		$j = $j + 1
		If $j > UBound($NewARPArray) Then ExitLoop ;Voodoo to fix weird Inf loop
	Next

	;_ArrayDisplay($OldARPArray)
	$OldARPArray = $NewARPArray
	;_ArrayDisplay($OldARPArray)
	;Sleep(1000)
	$NewARPArray = LoadARPArray(GetARPTable())
EndFunc   ;==>Do_ARP_Watch

Func GetARPTable()
	Local $foo, $line, $output
	;@ComSpec & " /c " &
	$foo = Run("arp -a", @SystemDir, @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
	;ProcessWait("arp.exe", 30)
	;ConsoleWrite($foo & crlf )
	While 1
		$line = StdoutRead($foo)
		If @error Then ExitLoop
		$output = $output & $line
	WEnd
	StdioClose($foo)
	Return $output
EndFunc   ;==>GetARPTable


Func LoadARPArray($input)
	$tmpARPArray1 = StringSplit($input, @CRLF)
	$tmpARPStr = ""
	For $line In $tmpARPArray1
		If StringLen($line) = 56 Then
			$tmpARPStr = $tmpARPStr & $line
		EndIf
	Next
	$tmpARPStr = StringReplace($tmpARPStr, 'dynamic', "")
	$tmpARPStr = StringReplace($tmpARPStr, 'invalid', "")
	$tmpARPStr = StringStripWS(StringStripWS(StringStripWS($tmpARPStr, 4), 1), 2)
	$1DimArpArray = StringSplit($tmpARPStr, ' ')
	If @error = 1 Then Return
	Local $2DimArpArray[($1DimArpArray[0] / 2)][2]
	$i = 1
	$j = 0
	While $i < $1DimArpArray[0]
		$2DimArpArray[$j][0] = $1DimArpArray[$i]
		$2DimArpArray[$j][1] = $1DimArpArray[$i + 1]
		$i = $i + 2
		$j = $j + 1
	WEnd
	_ArraySort($2DimArpArray, 0)
	;_ArrayDisplay($2DimArpArray)
	Return $2DimArpArray
EndFunc   ;==>LoadARPArray


Func Get_MAC_of_IP_From_Array($input_array, $ip)
	Local $i
	$i = _ArraySearch($input_array, $ip)
	If $i = -1 Then
		Return "00-00-00-00-00-00"
	Else
		$output_array = $input_array[$i][1]
		Return $output_array
	EndIf
EndFunc   ;==>Get_MAC_of_IP_From_Array

Func Do_Eventlog()
	$hEventLog = _EventLog__Open("", "Security")
	$aEvent = _EventLog__Read($hEventLog, True, False)
	;MsgBox(0,"x",$IgnoreEventIDs)
	If $oldrecnum <> $aEvent[1] And Not StringInStr($IgnoreEventIDs, $aEvent[6]) Then

		$line = "Event ID:" & $aEvent[6] & @CRLF

		$line = $line & StringReplace(StringReplace($aEvent[13], @CRLF & @CRLF, @CRLF), "	", "") & @CRLF
		;MsgBox(0,"x",$line)
		_TrayTip($nTrayIcon, "Security Log", $line, 30, 4)
		FileWrite("idslog.txt", @YEAR & @MON & @MDAY & @HOUR & @MIN & @SEC & ": " & $line & @CRLF)
		$oldrecnum = $aEvent[1]
	EndIf
	_EventLog__Close($hEventLog)

EndFunc   ;==>Do_Eventlog

Func MatchNetwork($match, $ar)
	If StringLeft($ar[5], StringLen($match)) = $match Then
		Return True
	Else
		Return False
	EndIf
EndFunc   ;==>MatchNetwork



Func Do_FireWall_Log()
	If $fwfilesize < FileGetSize($WinFWLog) Then
		$fwfilesize = FileGetSize($WinFWLog)
		$chars = FileReadLine($fwfile, _FileCountLines($WinFWLog))
		$ar = StringSplit($chars, " ")
		;If @error = -1 Then EndFunc
		If $ar[0] = 17 And Not MatchNetwork($IgnoreNetworkSrc, $ar) Then
			$o = "date:" & $ar[1] & @CRLF _
					 & "time:" & $ar[2] & @CRLF _
					 & "action:" & $ar[3] & @CRLF _
					 & "protocol:" & $ar[4] & @CRLF _
					 & "src-ip:" & $ar[5] & @CRLF _
					 & "src-name:" & _TCPIpToName($ar[5]) & @CRLF _
					 & "dst-ip:" & $ar[6] & @CRLF _
					 & "dst-name:" & _TCPIpToName($ar[6]) & @CRLF _
					 & "src-port:" & $ar[7] & @CRLF _
					 & "dst-port:" & $ar[8] & @CRLF _
					 & "size:" & $ar[9] & @CRLF _
					 & "tcpflags:" & $ar[10] & @CRLF _
					 & "info path:" & $ar[17] & @CRLF
			_TrayTip($nTrayIcon, "Firewall Log", $o, 30, 4)
			FileWrite("idslog.txt", @YEAR & @MON & @MDAY & @HOUR & @MIN & @SEC & ": " & $o & @CRLF)
			;Say($o)
		EndIf
	EndIf

EndFunc   ;==>Do_FireWall_Log


Func IP_Gateway_List()
	Local $output
	$wbemFlagReturnImmediately = 0x10
	$wbemFlagForwardOnly = 0x20
	$colItems = ""
	$strComputer = "localhost"
	$objWMIService = ObjGet("winmgmts:\\" & $strComputer & "\root\CIMV2")
	$colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_NetworkAdapterConfiguration", "WQL", _
			$wbemFlagReturnImmediately + $wbemFlagForwardOnly)
	$output = ""
	If IsObj($colItems) Then
		For $objItem In $colItems
			$strDefaultIPGateway = $objItem.DefaultIPGateway(0)
			$output = $output & " " & $strDefaultIPGateway
		Next
	Else
		; Do Notda
	EndIf
	Return $output
EndFunc   ;==>IP_Gateway_List

#cs
	Func Say($input)
	$oSp = ObjCreate("SAPI.SpVoice")
	;$oSp.LanguageID = DEC("0409")   ;hex 0409 is english...
	$oSp.Speak($input)
	EndFunc   ;==>Say
#ce

_TrayIconDelete($nTrayIcon) ; safely remove the sys-tray icon
Exit (0) ; exit the program